/*
	A basic extension of the java.awt.Frame class
 */
 
import java.awt.*;
import java.io.*;
import java.util.zip.*;
import java.util.*;

public class MazeEditor extends Frame
{
    MazeGraphics maze;
    MazeWorld myMazeWorld;
    int maze_x, maze_y;
    int edit_state;
    int roboDirection;
    static final int WALLS = 1;
    static final int GOLDS = 2;
    static final int ROBOTS = 3;
	public MazeEditor()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(insets().left + insets().right + 527,insets().top + insets().bottom + 307);
		button_x = new java.awt.Button();
		button_x.setActionCommand("button");
		button_x.setLabel("x");
		button_x.setBounds(insets().left + 216,insets().top + 84,49,24);
		button_x.setBackground(new Color(12632256));
		add(button_x);
		button_y = new java.awt.Button();
		button_y.setActionCommand("button");
		button_y.setLabel("y");
		button_y.setBounds(insets().left + 96,insets().top + 144,24,50);
		button_y.setBackground(new Color(12632256));
		add(button_y);
		button_walls = new java.awt.Button();
		button_walls.setActionCommand("button");
		button_walls.setLabel("walls");
		button_walls.setBounds(insets().left + 12,insets().top + 48,44,24);
		button_walls.setBackground(new Color(12632256));
		add(button_walls);
		button_golds = new java.awt.Button();
		button_golds.setActionCommand("button");
		button_golds.setLabel("golds");
		button_golds.setBounds(insets().left + 12,insets().top + 84,44,24);
		button_golds.setBackground(new Color(12632256));
		add(button_golds);
		button_robotN = new java.awt.Button();
		button_robotN.setActionCommand("button");
		button_robotN.setLabel("robotN");
		button_robotN.setBounds(insets().left + 12,insets().top + 120,44,24);
		button_robotN.setBackground(new Color(12632256));
		add(button_robotN);
		button_load = new java.awt.Button();
		button_load.setActionCommand("button");
		button_load.setLabel("load...");
		button_load.setBounds(insets().left + 72,insets().top + 12,51,20);
		button_load.setBackground(new Color(12632256));
		add(button_load);
		button_save = new java.awt.Button();
		button_save.setActionCommand("button");
		button_save.setLabel("save...");
		button_save.setBounds(insets().left + 144,insets().top + 12,51,20);
		button_save.setBackground(new Color(12632256));
		add(button_save);
		button_robotW = new java.awt.Button();
		button_robotW.setActionCommand("button");
		button_robotW.setLabel("robotW");
		button_robotW.setBounds(insets().left + 12,insets().top + 156,44,24);
		button_robotW.setBackground(new Color(12632256));
		add(button_robotW);
		button_robotS = new java.awt.Button();
		button_robotS.setActionCommand("button");
		button_robotS.setLabel("robotS");
		button_robotS.setBounds(insets().left + 12,insets().top + 192,44,24);
		button_robotS.setBackground(new Color(12632256));
		add(button_robotS);
		button_robotE = new java.awt.Button();
		button_robotE.setActionCommand("button");
		button_robotE.setLabel("robotE");
		button_robotE.setBounds(insets().left + 12,insets().top + 228,44,24);
		button_robotE.setBackground(new Color(12632256));
		add(button_robotE);
		maxDepthField = new java.awt.TextField();
		maxDepthField.setText("10");
		maxDepthField.setBounds(insets().left + 288,insets().top + 12,60,18);
		maxDepthField.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(maxDepthField);
		maxDepthLabel = new java.awt.Label("Max Depth:");
		maxDepthLabel.setBounds(insets().left + 216,insets().top + 12,72,18);
		maxDepthLabel.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(maxDepthLabel);
		button_robotAll = new java.awt.Button();
		button_robotAll.setActionCommand("button");
		button_robotAll.setLabel("robot*");
		button_robotAll.setBounds(insets().left + 12,insets().top + 264,44,24);
		button_robotAll.setBackground(new Color(12632256));
		add(button_robotAll);
		setTitle("Maze Editor");
		//}}
        this.setVisible(true);
        this.maze_x = insets().left + 70;
        this.maze_y = insets().top + 36;
        maze = new MazeGraphics(this, 2, 2, 
                  this.maze_x, this.maze_y);
        maze.refresh();
        moveButtons();
        this.buttonWalls_MouseClick(null);
		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		button_x.addMouseListener(aSymMouse);
		button_y.addMouseListener(aSymMouse);
		this.addMouseListener(aSymMouse);
		button_walls.addMouseListener(aSymMouse);
		button_golds.addMouseListener(aSymMouse);
		button_robotN.addMouseListener(aSymMouse);
		button_save.addMouseListener(aSymMouse);
		button_load.addMouseListener(aSymMouse);
		button_robotW.addMouseListener(aSymMouse);
		button_robotS.addMouseListener(aSymMouse);
		button_robotE.addMouseListener(aSymMouse);
		SymAction lSymAction = new SymAction();
		button_robotAll.addActionListener(lSymAction);
		button_robotAll.addMouseListener(aSymMouse);
		//}}
	}

	public MazeEditor(String title)
	{
		this();
		setTitle(title);
	}

	public synchronized void show()
	{
		move(50, 50);
		super.show();
	}

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	java.awt.Button button_x;
	java.awt.Button button_y;
	java.awt.Button button_walls;
	java.awt.Button button_golds;
	java.awt.Button button_robotN;
	java.awt.Button button_load;
	java.awt.Button button_save;
	java.awt.Button button_robotW;
	java.awt.Button button_robotS;
	java.awt.Button button_robotE;
	java.awt.TextField maxDepthField;
	java.awt.Label maxDepthLabel;
	java.awt.Button button_robotAll;
	//}}

	//{{DECLARE_MENUS
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == MazeEditor.this)
				MazeEditor_WindowClosing(event);
		}
	}
	
	void MazeEditor_WindowClosing(java.awt.event.WindowEvent event)
	{
		hide();		 // hide the Frame
	}
	
	public void paint(Graphics g)
	{
	    if (this.maze != null)
	        maze.update();	   
	} // paint()
	
	// updates position of x and y buttons //
	public void moveButtons()
	{
        button_x.setLocation(this.maze_x+ 5 +
                             (maze.width*maze.cellsize),
                             this.maze_y - 12 +
                             (int)(maze.height*maze.cellsize*0.5));
        button_y.setLocation(this.maze_x - 12 +
                             (int)(maze.width*maze.cellsize*0.5),
                             this.maze_y+5+
                             (maze.height*maze.cellsize));
	} // moveButtons()

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == button_x)
				buttonX_MouseClick(event);
			else if (object == button_y)
				buttonY_MouseClick(event);
			else if (object == MazeEditor.this)
				MazeEditor_MouseClick(event);
			else if (object == button_walls)
				buttonWalls_MouseClick(event);
			else if (object == button_golds)
				buttonGolds_MouseClick(event);
			else if (object == button_robotN)
				buttonRobotN_MouseClick(event);
			else if (object == button_save)
				buttonSave_MouseClick(event);
			else if (object == button_load)
				buttonLoad_MouseClick(event);
			else if (object == button_robotW)
				buttonRobotW_MouseClick(event);
			else if (object == button_robotS)
				buttonRobotS_MouseClick(event);
			else if (object == button_robotE)
				buttonRobotE_MouseClick(event);
			else if (object == button_robotAll)
				buttonRobotAll_MouseClick(event);
		}
	}

    // increase width of maze by one (and reinstantiate)
	void buttonX_MouseClick(java.awt.event.MouseEvent event)
	{
        int x = this.maze.width;
        int y = this.maze.height;
        this.maze = new MazeGraphics(this, x+1, y, 
                  this.maze_x, this.maze_y);
        this.moveButtons();
        this.maze.refresh();
	} // buttonX_MouseClick() //

	void buttonY_MouseClick(java.awt.event.MouseEvent event)
	{
        int x = this.maze.width;
        int y = this.maze.height;
        this.maze = new MazeGraphics(this, x, y+1, 
                  this.maze_x, this.maze_y);
        this.moveButtons();
        this.maze.refresh();
	} // buttonY_MouseClick() //

	void MazeEditor_MouseClick(java.awt.event.MouseEvent event)
	{
	    switch (this.edit_state) {
	        case MazeEditor.WALLS:
	            this.wallClick(event);
	            break;
	        case MazeEditor.GOLDS:
	            this.goldClick(event);
	            break;
	        case MazeEditor.ROBOTS:
	            this.robotClick(event);
	            break;
	    } // endswitch
        this.maze.refresh();
	} // MazeEditor_MouseClick() //
	
	public boolean nearCenter(int x)
	{
	    return ((Math.abs((x % this.maze.cellsize) - 
	                      (this.maze.cellsize/2)))
	                <
	            (this.maze.cellsize/4));
	} // nearCenter() //
	
	public boolean inXBounds(int x)
	{
	    return((x/this.maze.cellsize) < this.maze.width);
	}
	public boolean inYBounds(int y)
	{
	    return((y/this.maze.cellsize) < this.maze.height);
	}
	public boolean nearEdge(int x)
	{
	    return((x % this.maze.cellsize) < 10);
	}
	public int getXCell(int x)
	{
        return(x/this.maze.cellsize);	    
	}
	public int getYCell(int y)
	{
	    return(this.maze.height - 1 - (y/this.maze.cellsize));
	}
	
	public void goldClick(java.awt.event.MouseEvent event)
	{
	    int mouse_x = event.getX()+5; int mouse_y=event.getY()+5;
	    int dx = mouse_x - this.maze_x;
	    int dy = mouse_y- this.maze_y;
	    
	    if (this.nearCenter(dx) && this.nearCenter(dy) &&
	        this.inXBounds(dx) && this.inYBounds(dy)) {
	        //in this case, gold goes in a single cell//
	        int cx=this.getXCell(dx); int cy=this.getYCell(dy);
	        if (this.maze.removeGold(cx,cy))
	            return;
	            else this.maze.addGold(cx,cy);	    
	    }  // endif
	    else if (this.nearEdge(dx) && this.inXBounds(dx) &&
	             this.inYBounds(dy)) {
	        //put gold on a vertical wall//
	        /* TEMPORARILY DISABLED 
	        int cx=this.getXCell(dx); int cy=this.getYCell(dy);
	        if (this.maze.removeGold(cx,cy,cx-1,cy))
	            return;
	            else this.maze.addGold(cx,cy,cx-1,cy);
	         END TEMPORARILY DISABLED */
	    } // end  else if (this.nearEdge(dx... //
	    else if (this.nearEdge(dy) && this.inXBounds(dx) &&
	             this.inYBounds(dy)) {
	        // put gold on a horizontal wall //
	        /* TEMPORARILY DISABLED 
	        int cx=this.getXCell(dx); int cy=this.getYCell(dy);
	        if (this.maze.removeGold(cx,cy,cx,cy+1))
	            return;
	            else this.maze.addGold(cx,cy,cx,cy+1);
	         END TEMPORARILY DISABLED */
	    } // end else if (this.nearEdge(dy... //
	} // goldClick() //
	public void robotClick(java.awt.event.MouseEvent event)
	{
	    int mouse_x = event.getX();
	    int mouse_y = event.getY();
	    int dx = mouse_x - this.maze_x;
	    int dy = mouse_y - this.maze_y;
	    
	    // if the click's near the center of a cell...
	    if (this.nearCenter(dx) &&
	        this.nearCenter(dy)  &&
            this.inXBounds(dx) &&
            this.inYBounds(dy)
           ) {
                int cx = this.getXCell(dx);
                int cy = this.getYCell(dy);
                if (roboDirection == 4) {
                    if (this.maze.removeRobot(cx,cy,0,0)) {
                        for (int i=0; i < 4; i++) this.maze.removeRobot(cx,cy,i,0);
                    } else {
                        for (int i=0; i < 4; i++) this.maze.addRobot(cx,cy,i,0);
                    }
                } else {
                    if (this.maze.removeRobot(cx,cy,roboDirection,0)) {
                        return;
                    } else {
                        this.maze.addRobot(cx,cy,roboDirection,0);
                    }
                }
                /*
                for (int i=0; i<3; i++) {
                    if (this.maze.removeRobot(cx,cy,i,0)) {
                        this.maze.addRobot(cx,cy,i+1,0);
                        return;
                    } //endif
                } //end for (int i.. //
                if (this.maze.removeRobot(cx,cy,3,0))
                    return;
                this.maze.addRobot(cx,cy,0,0);
                */
           } //endif   
	} // robotClick() //
	public void wallClick(java.awt.event.MouseEvent event)
	{
        int mouse_x = event.getX() + 5;
        int mouse_y = event.getY() + 5;
        int dx = mouse_x - this.maze_x;
        int dy = mouse_y - this.maze_y;
        int cell_x, cell_y;
        
        if (this.nearEdge(dx) && this.inXBounds(dx) &&
            this.inYBounds(dy)) {
                // we've clicked for a vertical wall!
                int cx = this.getXCell(dx);
                int cy = this.getYCell(dy);
                if (maze.walls[cx][cy][1] == 0) {
                    // System.out.println("adding wall");
                    this.maze.addWall(cx,cy,1);
                }
                    else {
                        // System.out.println("removing wall");
                        this.maze.removeWall(cx,cy,1);
                    }
        } else if (this.nearEdge(dy) &&
            this.inXBounds(dx) && this.inYBounds(dy)) {
                // we've clicked for a horizontal wall!
                int cx = this.getXCell(dx);
                int cy = this.getYCell(dy);
                if (maze.walls[cx][cy][0] == 0)                  
                    this.maze.addWall(cx,cy,0);
                    else this.maze.removeWall(cx,cy,0);
        } //endelseif
	} // wallClick() //

	void buttonWalls_MouseClick(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		this.edit_state= MazeEditor.WALLS;
		button_walls.setBackground(Color.yellow);
		button_robotN.setBackground(new Color(12632256));
		button_robotW.setBackground(new Color(12632256));
		button_robotS.setBackground(new Color(12632256));
		button_robotE.setBackground(new Color(12632256));				
		button_golds.setBackground(new Color(12632256));
		button_robotAll.setBackground(new Color(12632256));
	} // buttonWalls_MouseClick() //

	void buttonGolds_MouseClick(java.awt.event.MouseEvent event)
	{
		this.edit_state= MazeEditor.GOLDS;
		button_golds.setBackground(Color.yellow);
		button_robotN.setBackground(new Color(12632256));
		button_robotW.setBackground(new Color(12632256));
		button_robotS.setBackground(new Color(12632256));
		button_robotE.setBackground(new Color(12632256));				
		button_walls.setBackground(new Color(12632256));
		button_robotAll.setBackground(new Color(12632256));
	} //buttonGolds_MouseClick() //

	void buttonRobotN_MouseClick(java.awt.event.MouseEvent event)
	{
		this.edit_state= MazeEditor.ROBOTS;
		this.roboDirection = 0;
		button_robotN.setBackground(Color.yellow);
		button_robotW.setBackground(new Color(12632256));
		button_robotS.setBackground(new Color(12632256));
		button_robotE.setBackground(new Color(12632256));		
		button_walls.setBackground(new Color(12632256));
		button_golds.setBackground(new Color(12632256));
		button_robotAll.setBackground(new Color(12632256));

	} //buttonRobots_MouseClick() //
	
	void buttonRobotW_MouseClick(java.awt.event.MouseEvent event)
	{
		this.edit_state= MazeEditor.ROBOTS;
		this.roboDirection = 1;
		button_robotW.setBackground(Color.yellow);
		button_robotN.setBackground(new Color(12632256));
		button_robotS.setBackground(new Color(12632256));
		button_robotE.setBackground(new Color(12632256));		
		button_walls.setBackground(new Color(12632256));
		button_golds.setBackground(new Color(12632256));
		button_robotAll.setBackground(new Color(12632256));
	}

	void buttonRobotS_MouseClick(java.awt.event.MouseEvent event)
	{
		this.edit_state= MazeEditor.ROBOTS;
		this.roboDirection = 2;
		button_robotS.setBackground(Color.yellow);
		button_robotW.setBackground(new Color(12632256));
		button_robotN.setBackground(new Color(12632256));
		button_robotE.setBackground(new Color(12632256));		
		button_walls.setBackground(new Color(12632256));
		button_golds.setBackground(new Color(12632256));
		button_robotAll.setBackground(new Color(12632256));
	}

	void buttonRobotE_MouseClick(java.awt.event.MouseEvent event)
	{
		this.edit_state= MazeEditor.ROBOTS;
		this.roboDirection = 3;
		button_robotN.setBackground(new Color(12632256));
		button_robotW.setBackground(new Color(12632256));
		button_robotS.setBackground(new Color(12632256));
		button_robotE.setBackground(Color.yellow);		
		button_walls.setBackground(new Color(12632256));
		button_golds.setBackground(new Color(12632256));
		button_robotAll.setBackground(new Color(12632256));

	}
	

	void buttonSave_MouseClick(java.awt.event.MouseEvent event)
	{
		// serialize the maze into a file!
		/* create a MazeWorld */
		myMazeWorld = new MazeWorld(this.maze.walls);
		myMazeWorld.height = this.maze.height;
		myMazeWorld.width = this.maze.width;
		myMazeWorld.maxDepth = Integer.parseInt(maxDepthField.getText());
		myMazeWorld.inits = maze.robots;
		myMazeWorld.goals = new Vector();
		for (int i=0; i < maze.golds.size(); i++) {
		    int goldspec [] = (int [])maze.golds.elementAt(i);
		    if (goldspec.length == 2) {
		        for (int j=0; j < 4; j++) {
		            int goalspec [] = new int[3];
		            goalspec[0] = goldspec[0];
		            goalspec[1] = goldspec[1];
		            goalspec[2] = j;
		            myMazeWorld.goals.addElement(goalspec);
		        }
		    }
		}		
		/* now save this MazeWorld we just created */
		FileDialog f = new FileDialog(this, "Save Maze",
		    FileDialog.SAVE);
		f.show();
		String filename = f.getFile();
		String directory = f.getDirectory();
		if (filename != null) {
		    try {
		        System.out.println("we are printing!");
		        FileOutputStream fos = new FileOutputStream(directory+filename);
		        GZIPOutputStream gzos = new GZIPOutputStream(fos);
		        ObjectOutputStream out = new ObjectOutputStream(gzos);
		        out.writeObject(this.myMazeWorld);
		        out.flush();
		        out.close();
		    } // endtry
		    catch (IOException e) { System.out.println(e); }
		} // endif
	} // buttonSave_MouseClick() //

	void buttonLoad_MouseClick(java.awt.event.MouseEvent event)
	{
	    // read in the file and then set the parent_frame in this object
	    // accordingly. then refresh.
	    FileDialog f = new FileDialog(this, "Load Maze", FileDialog.LOAD);
	    f.show();
	    String filename = f.getFile();
	    String directory = f.getDirectory();
	    if (filename != null) {
	        try {
	            this.maze.wipeMaze(); 
	            this.maze = new MazeGraphics(this, 2, 2, this.maze_x, this.maze_y);
	            
	            FileInputStream fis = new FileInputStream(directory+filename);
	            GZIPInputStream gzis = new GZIPInputStream(fis);
	            ObjectInputStream in = new ObjectInputStream(gzis);
	            this.myMazeWorld = (MazeWorld)in.readObject();
	            in.close();
	            this.maze.parent_frame = this;
                this.moveButtons();
	            this.maze.refresh();
	            
                maze = 
	            new MazeGraphics(this, myMazeWorld.width, myMazeWorld.height,
	                             this.maze_x,this.maze_y);
	            
	            /* set the depth field... */
	            maxDepthField.setText(Integer.toString(myMazeWorld.maxDepth));
	                                    
	            /* now add all the walls of this new maze */
	            for (int i=0; i< myMazeWorld.width; i++) {
	                for (int j=0; j < myMazeWorld.height; j++) {
	                    for (int k=0; k < 4; k++) {
	                        if (myMazeWorld.maze[i][j][k] == 1)
	                            maze.addWall(i,j,k);
	                    }
	                }
	            }
	            /* now add all the init robot positions to this maze */
	            int robotPos [];
	            if (myMazeWorld.inits != null) {
	                for (int i=0; i < myMazeWorld.inits.size(); i++) {
	                    robotPos = (int [])myMazeWorld.inits.elementAt(i);
	                    maze.addRobot(robotPos[0],robotPos[1],robotPos[2],0);
	                }
	            }
	            
	            /* now add the goal positions in G just by putting gold */
	            if (myMazeWorld.goals != null) {
	                System.out.println("Number of goals read in is: " +
	                                    myMazeWorld.goals.size());
	                for (int i=0; i < myMazeWorld.goals.size(); i++) {
	                    robotPos = (int [])myMazeWorld.goals.elementAt(i);
	                    
	                    // new line below to ensure we don't have duplication and replication! 
	                    // Illah 10/10/1999
	                    maze.removeGold(robotPos[0],robotPos[1]);
	                    
	                    maze.addGold(robotPos[0],robotPos[1]);
	                }
	            }		
	            
                this.moveButtons();
                this.maze.refresh();
	            
	            
	        } catch (Exception e) {this.maze.refresh();
	                               System.out.println(e); }
	    } //endif
   	}// buttonLoad_MouseClick() //


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button_robotAll)
				buttonRobotAll_Action(event);
		}
	}

	void buttonRobotAll_Action(java.awt.event.ActionEvent event)
	{
	}

	void buttonRobotAll_MouseClick(java.awt.event.MouseEvent event)
	{
		this.edit_state= MazeEditor.ROBOTS;
		this.roboDirection = 4;
		button_robotN.setBackground(new Color(12632256));
		button_robotW.setBackground(new Color(12632256));
		button_robotS.setBackground(new Color(12632256));
		button_robotE.setBackground(new Color(12632256));
		button_walls.setBackground(new Color(12632256));
		button_golds.setBackground(new Color(12632256));
	    button_robotAll.setBackground(Color.yellow);
	}
}
